#ifndef CONFIGURATION_H
#define CONFIGURATION_H
// $Id: configuration.h,v 1.1 2001/04/16 17:43:04 dvermeir Exp $

#include <iostream>
#include <set>
#include "expression.h"

//! A Configuration object represents the httpstats configuration.
class Configuration {
public:
  enum CRITERIUM { DATE, PATH, DOMAIN, NONE };
  Configuration();
  ~Configuration();

  CRITERIUM       format() const { return format_; }
  unsigned int    max_level() const { return max_level_; }
  const set<unsigned int>& levels() const { return levels_; }
  const set<CRITERIUM>& criteria() const { return criteria_; }
  const Expression*     select() const { return select_; }

  unsigned int parse(istream&);


  friend ostream& operator<<(ostream&,const Configuration&);

protected: 
  bool parse_format(istream&);
  bool parse_select(istream&);
  bool parse_exclude(istream&);
  Expression* parse_expression(istream&);
  CRITERIUM parse_criterium(istream&);
  bool parse_levels(istream&,set<unsigned int>& levels);

  void add_expression(Expression* e);
private:
  CRITERIUM         format_;
  set<CRITERIUM>    criteria_;
  set<unsigned int> levels_;
  unsigned int      max_level_;
  AndExpression*    select_;
};

ostream& operator<<(ostream&,const Configuration::CRITERIUM&);
#endif

