#ifndef DATE_PATTERN_H
#define DATE_PATTERN_H

// $Id: datepattern.h,v 1.1 2001/04/16 17:43:05 dvermeir Exp $
#include <string>
#include <vector>
#include <iostream>

class DatePattern {
public:
  DatePattern() {}
  
  //! Construct DatePattern containing first l components of p.
  DatePattern(const DatePattern& p,unsigned int l);

  //! Parses 1999-03-12 10:00, 1999-3-12, 1999-3, 1999
  bool parse(const string& date_string); 
  // Set max no of components explicitly.
  void set(unsigned int year, unsigned int month, unsigned int day, unsigned int hours);

  const unsigned int operator[](unsigned int i) const { return date_[i]; }
  unsigned int size() const { return date_.size(); }

  bool operator==(const DatePattern& p) const { return date_ == p.date_; }
  bool operator<(const DatePattern& p) const { return date_ < p.date_; }

  typedef vector<unsigned int>::const_iterator iterator;
  iterator begin() const { return date_.begin(); }
  iterator end() const { return date_.end(); }

  friend ostream& operator<<(ostream&,const DatePattern&);
private:
  //! 0 = year, 1 = month, 2 = day, 3 = hours
  vector<unsigned int> date_; 
};

#endif
