// $Id: domain.C,v 1.1 2001/04/16 17:43:05 dvermeir Exp $
#include "domain.h"

Domain::Domain(const Domain& d, unsigned int n) {
unsigned int m(min(d.size(),n));
list<string>::const_iterator i=d.data().begin();

for (unsigned int j=1; j<=m; ++j) 
  domain_.push_back(*i++);
}

// Parse a string "tinf2.vub.ac.be" as <"be","ac","vub","tinf2">.
bool
Domain::parse(const string& ds) {
domain_.clear();
string::size_type n0(ds.find_first_not_of('.'));
if (n0!=0)
  return false;
string::size_type n1(string::npos);

while ((n1 = ds.find_first_of('.',n0)) != string::npos) {
  if (n1>n0)
    domain_.push_front(ds.substr(n0,n1-n0));
  n0 = n1+1;
  }
// If domain does not end with '.', we still need to add a final component.
if (n0<ds.size()) 
  domain_.push_front(ds.substr(n0));
return true;
}

ostream&
operator<<(ostream& os,const Domain& d) {
for (list<string>::const_iterator i=d.data().begin(); i!=d.data().end(); ++i) {
  if (i!=d.data().begin())
    os << ".";
  os << (*i);
  }
return os;
}
