#ifndef LOGRECORD_H
#define LOGRECORD_H
// $Id: logrecord.h,v 1.1 2001/04/16 17:43:06 dvermeir Exp $ 
#include <string>
#include <vector>
#include "datepattern.h"
#include "path.h"
#include "domain.h"

class Configuration;

class LogRecord {
public:
  LogRecord() {}

  //! fill in date_, domain_, path_ from line.
  bool parse_line(const string& line,const Configuration& conf); 

  const DatePattern& date() const { return date_; }
  const Path& path() const { return path_; }
  const Domain& domain() const { return domain_; }

private:
  //! Auxiliary function for parse_line().
  bool parse_date(const string& line);
  //! Auxiliary function for parse_line().
  bool parse_path(const string& line);
  //! Auxiliary function for parse_line().
  bool parse_domain(const string& line);

  DatePattern    date_;
  Path   path_;
  Domain domain_;
};

#endif
