#ifndef PATH_H
#define PATH_H

// $Id: path.h,v 1.1 2001/04/16 17:43:06 dvermeir Exp $
#include <string>
#include <vector>

class Path {
public:
  Path() {}
  //! Construct path containing first l components of p.
  Path(const Path& p,unsigned int l);

  //! Note that path_string may not contain leading or trailing white space.
  bool parse(const string& path_string); 

  //! Return string representation of Path.
  const string& str() const;

  const string& operator[](unsigned int i) const { return path_[i]; }
  unsigned int size() const { return path_.size(); }

  bool operator==(const Path& p) const { return path_ == p.path_; }
  bool operator<(const Path& p) const { return path_ < p.path_; }
  
  typedef vector<string>::const_iterator iterator;
  iterator begin() const { return path_.begin(); }
  iterator end() const { return path_.end(); }

  friend ostream& operator<<(ostream&,const Path& path);
private:
  vector<string> path_;
  //! Memo of string representation for Path::str().
  mutable string str_; 
};

#endif
